/******************************************************************************
Ootake
EWindow\ɂDirectDrawg悤ɂB
E񂵋@\tB

Copyright(C)2006-2007 Kitao Nakamura.
	ŁEpłJȂƂ͕K\[XR[hYtĂB
	̍ۂɎł܂܂̂ŁAЂƂƂm点ƍKłB
	Iȗp͋ւ܂B
	Ƃ́uGNU General Public License(ʌOp_)vɏ܂B

*******************************************************************************
	[Screen.c]

	Implement ScreenInterface.

	Copyright (C) 2004 Ki

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
******************************************************************************/
#include "Screen.h"
#include "DDScreen.h"
//#include "GDIScreen.h"
#include "TIMER.h"
#include "VDC.h"
#include "CDROM.h"
#include "APU.h"

static Sint32	_Width;
static Sint32	_Height;
static Sint32	_Magnification; //Kitaoǉ
static Sint32	_BitsPerPixel;
static Uint32	_Flags;

static Sint32	_FastForwardingCount; //Kitaoǉ


/*-----------------------------------------------------------------------------
	[Init]
		XN[܂B 
-----------------------------------------------------------------------------*/
BOOL
SCREEN_Init(
	Sint32		width,
	Sint32		height,
	Sint32		magnification, //Kitaoǉ
	Sint32		bitsPerPixel,
	Uint32		flags)
{
	_Width = width;
	_Height = height;
	_Magnification = magnification; //Kitaoǉ
	_BitsPerPixel = bitsPerPixel;
	_Flags = flags;

	SCREEN_ResetFastForwardingCount(); //Kitaoǉ

	return DDSCREEN_Init(width, height, magnification, bitsPerPixel, flags);
}


//KitaoǉB񂵗p̃JE^
void
SCREEN_ResetFastForwardingCount()
{
	_FastForwardingCount = 1;
}


/*-----------------------------------------------------------------------------
	[GetWidth]
	  XN[̉Ԃ܂B
-----------------------------------------------------------------------------*/
Sint32
SCREEN_GetWidth()
{
	return DDSCREEN_GetWidth();
}


/*-----------------------------------------------------------------------------
	[GetHeight]
	  XN[̍Ԃ܂B
-----------------------------------------------------------------------------*/
Sint32
SCREEN_GetHeight()
{
	return DDSCREEN_GetHeight();
}


/*-----------------------------------------------------------------------------
	[GetRshift]
	  ꂽOtBbN[hŁCԐFɉrbgVtg邩
	Ԃ܂D(Ⴆ16bppł11C15bppł10)
**---------------------------------------------------------------------------*/
Sint32
SCREEN_GetRshift()
{
	return DDSCREEN_GetRshift();
}


/*-----------------------------------------------------------------------------
	[GetGshift]
	  ꂽOtBbN[hŁCΐFɉrbgVtg邩
	Ԃ܂D(Ⴆ16bppł5C15bppł5)
**---------------------------------------------------------------------------*/
Sint32
SCREEN_GetGshift()
{
	return DDSCREEN_GetGshift();
}


/*-----------------------------------------------------------------------------
	[GetBshift]
	  ꂽOtBbN[hŁCFɉrbgVtg邩
	Ԃ܂D(Ⴆ16bppł0C15bppł0)
**---------------------------------------------------------------------------*/
Sint32
SCREEN_GetBshift()
{
	return DDSCREEN_GetBshift();
}


/*-----------------------------------------------------------------------------
	[GetRmask]
	  ꂽOtBbN[hŁCԐF}XNrbgԂ܂D
	Ԃ܂D(Ⴆ16bppł0xf800, 15bppł 0x7c00)
**---------------------------------------------------------------------------*/
Uint32
SCREEN_GetRmask()
{
	return DDSCREEN_GetRmask();
}


/*-----------------------------------------------------------------------------
	[GetGmask]
	  ꂽOtBbN[hŁCΐF}XNrbgԂ܂D
	Ԃ܂D(Ⴆ16bppł0x07e0, 15bppł 0x03e0)
**---------------------------------------------------------------------------*/
Uint32
SCREEN_GetGmask()
{
	return DDSCREEN_GetGmask();
}


/*-----------------------------------------------------------------------------
	[GetBmask]
	  ꂽOtBbN[hŁCF}XNrbgԂ܂D
	Ԃ܂D(Ⴆ16bppł0x001f, 15bppł 0x001f)
**---------------------------------------------------------------------------*/
Uint32
SCREEN_GetBmask()
{
	return DDSCREEN_GetBmask();
}


/*-----------------------------------------------------------------------------
	[GetBytesPerPixel]
	  PsNZɎgpoCgԂ܂D
**---------------------------------------------------------------------------*/
Uint32
SCREEN_GetBytesPerPixel()
{
	return DDSCREEN_GetBytesPerPixel();
}


/*-----------------------------------------------------------------------------
	[PutPixel]
	  PsNZ`܂D16bpp p
**---------------------------------------------------------------------------*/
void
SCREEN_PutPixel(
	Sint32		x,
	Sint32		y,
	Uint32		pixel)
{
	DDSCREEN_PutPixel(x, y, pixel);
}


/*-----------------------------------------------------------------------------
	[IsFullScreen]
		XN[tXN[Ȃ TRUE, EChEȂ FALSE Ԃ܂B
-----------------------------------------------------------------------------*/
BOOL
SCREEN_IsFullScreen()
{
	return (_Flags & SCREEN_FFULLSCREEN) != 0;
}


/*-----------------------------------------------------------------------------
	[ToggleFullScreen]
		XN[EChE^tXN[ɐ؂ւ܂D
-----------------------------------------------------------------------------*/
BOOL
SCREEN_ToggleFullScreen()
{
	DDSCREEN_Deinit();
	if (_Flags & SCREEN_FFULLSCREEN)
		_Flags &= ~SCREEN_FFULLSCREEN;
	else
		_Flags |= SCREEN_FFULLSCREEN;
	return DDSCREEN_Init(_Width, _Height, _Magnification, _BitsPerPixel, _Flags);
}


/*-----------------------------------------------------------------------------
	[ChangeMode]
		XN[[hύX܂B 
-----------------------------------------------------------------------------*/
BOOL
SCREEN_ChangeMode(
	Sint32		width,
	Sint32		height,
	Sint32		magnification, //Kitaoǉ
	Uint32		bpp,
	Uint32		flags)
{
	DDSCREEN_Deinit();

	_Width = width;
	_Height = height;
	_Magnification = magnification; //Kitaoǉ
	_BitsPerPixel = bpp;
	_Flags = flags;

	return DDSCREEN_Init(width, height, magnification, bpp, flags);
}


/*-----------------------------------------------------------------------------
	[SetFPS]
		Frames Per Second ύX܂B 
-----------------------------------------------------------------------------*/
void
SCREEN_SetFPS(
	float		fps)
{
	DDSCREEN_SetFPS(fps);
}


//KitaoǉB񂵋@\̂߂̏B񂵒̓t[XLbvB
//fastForwardingB0cʏB
//				  2c1.5{[hB3c1.33{[hB4c1.25{[hB5ȍ~(1+(1/n)){[hB
//				  102c2{[hB103c3{[hB104c4{[hB105ȍ~(n-100){[hB
//				  1000c1.83{[h(2{ƈႢt[ôŃt[XLbv̉eȂ߁Aʂɍ̗p)B
//				  1001c1.67{[h(2{ƈႢt[ôŃt[XLbv̉eȂ߁Aʂɍ̗p)B
//				  2002c0.5{[hB2004c0.75{[hB2010c0.90{[hB

inline int
fastForwardingCheck()
{
	Sint32	fastForwarding = TIMER_GetFastForwardingNow();

	if (fastForwarding == 0)
		return 1;
	else if (fastForwarding == 1000) //1.83{[h̏ꍇ
	{
		if ((_FastForwardingCount-- % 2) == 1) //(1,3,5,7,9,11)̂Ƃ`
		{
			if (_FastForwardingCount == 0)
				_FastForwardingCount = 11; //116񂾂`(EFCg)
			return 1;
		}
	}
	else if (fastForwarding == 1001) //1.67{[h̏ꍇ
	{
		if ((_FastForwardingCount-- % 2) == 1) //(1,3,5)̂Ƃ`
		{
			if (_FastForwardingCount == 0)
				_FastForwardingCount = 5; //53񂾂`(EFCg)
			return 1;
		}
	}
	else if (fastForwarding <= 100)
	{
		if (_FastForwardingCount-- <= fastForwarding)
		{
			if (_FastForwardingCount == 0)
				_FastForwardingCount = fastForwarding + 1; //(fastForwarding+1)(fastForwarding)񂾂`(EFCg)
			return 1;
		}
	}
	else if (fastForwarding == 2002) //0.5{[h̏ꍇ
		return 2; //QVBlank҂s
	else if (fastForwarding >= 2003) //0.67{ȉ̃[h̏ꍇ
	{
		if (_FastForwardingCount-- <= fastForwarding-2000-2)
		{
			if (_FastForwardingCount == 0)
				_FastForwardingCount = fastForwarding-2000-1; //(fastForwarding-1)(fastForwarding-2)́AP񂾂VBlank҂B
			return 1;
		}
		return 2; //QVBlank҂s
	}
	else //(fastForwarding > 100) Q{ȏBQ{OオtBȏ͌̃p\Rł͏
	{
		if (--_FastForwardingCount == 0)
		{
			_FastForwardingCount = (fastForwarding-100); //(_FastForwardingCount1)ɂP񂾂`(EFCg)
			return 1;
		}
	}
	return 0;
}

/*-----------------------------------------------------------------------------
	[WaitVBlank]
		AԂ҂܂B 
-----------------------------------------------------------------------------*/
//KitaoXV
BOOL
SCREEN_WaitVBlank()
{
	int		i;

	//KitaoǉB񂵋@\̂߂̏B񂵒̓t[XLbvB
	switch (fastForwardingCheck())
	{
		case 1:
			return DDSCREEN_WaitVBlank();
		case 2:
			DDSCREEN_WaitVBlank();
			for (i=1; i<=7159090/60; i++) //r؂Ȃ悤ɂPt[ԂCD-ROMAPUi߂
			{
				CDROM_AdvanceClock();
				APU_AdvanceClock(); //KitaoXVBCDDAȂǂ̂߁ACDROMIĂAPU
			}
			return DDSCREEN_WaitVBlank();
		default:
			return TRUE;
	}
}


/*-----------------------------------------------------------------------------
	[ShouldDraw]
		`sȂׂAsȂȂׂԂ܂B 
-----------------------------------------------------------------------------*/
BOOL
SCREEN_ShouldDraw()
{
	return DDSCREEN_ShouldDraw();
}


/*-----------------------------------------------------------------------------
	[Lock]
		XN[bNKv΃bN܂B
-----------------------------------------------------------------------------*/
BOOL
SCREEN_Lock()
{
	return DDSCREEN_Lock();
}


void*
SCREEN_GetBuffer()
{
	return DDSCREEN_GetBuffer();
}


const Sint32
SCREEN_GetBufferPitch()
{
	return DDSCREEN_GetBufferPitch();
}


/*-----------------------------------------------------------------------------
	[Unlock]
		XN[̃bN܂B
-----------------------------------------------------------------------------*/
void
SCREEN_Unlock()
{
	DDSCREEN_Unlock();
}


/*-----------------------------------------------------------------------------
	[DrawText]
		obNobt@ɕ݂܂B 
	ĂԑO SCREEN_Lock() ܂傤B
-----------------------------------------------------------------------------*/
void
SCREEN_DrawText(
	const Sint32	x,
	const Sint32	y,
	const Uint32	fgColor,
	const Uint32	bgColor,
	const BOOL		bOpaque,
	const char*		pText)
{
	DDSCREEN_DrawText(x, y, fgColor, bgColor, bOpaque, pText);
}


/*-----------------------------------------------------------------------------
	[FillRect]
		obNobt@Ɏw̐F̋``܂B
	ĂԑO SCREEN_Lock() ܂傤B
-----------------------------------------------------------------------------*/
void
SCREEN_FillRect(
	Sint32		x,
	Sint32		y,
	Sint32		width,
	Sint32		height,
	Uint32		color)
{
	DDSCREEN_FillRect(x, y, width, height, color);
}


/*-----------------------------------------------------------------------------
	[Blt]
		pSrc obNobt@։摜݂܂Bg^kA
	ĂԑO SCREEN_Lock() ܂傤B
-----------------------------------------------------------------------------*/
void
SCREEN_Blt(
	const void*		pSrc,
	Sint32			srcX,
	Sint32			srcY,
	Uint16*			pTvW, //Kitaoǉ
	Sint32			srcW,
	Sint32			srcH) //KitaoXVBdstWdstH ̓JbgB(ŌŒ肹AlXȑ傫ł̃y[XgɑΉ邽)
{
	int		i;

	//KitaoǉB񂵋@\̂߂̏B񂵒̓t[XLbvB
	switch (fastForwardingCheck())
	{
		case 1:
			DDSCREEN_Blt(pSrc, srcX, srcY, pTvW, srcW, srcH);
			break;
		case 2:
			DDSCREEN_Blt(pSrc, srcX, srcY, pTvW, srcW, srcH);
			for (i=1; i<=7159090/60; i++) //r؂Ȃ悤ɂPt[ԂCD-ROMAPUi߂
			{
				CDROM_AdvanceClock();
				APU_AdvanceClock(); //KitaoXVBCDDAȂǂ̂߁ACDROMIĂAPU
			}
			DDSCREEN_WaitVBlank(); //Ađ҂ꍇABlt̂ƂłȂƂ܂҂ĂȂBBlt̑Oł͑ʖځB
			break;
	}
}


//KitaoǉBVSync(A҂)sǂݒ
void
SCREEN_SetSyncTo60HzScreen(
	BOOL	bSyncTo60HzScreen)
{
	DDSCREEN_SetSyncTo60HzScreen(bSyncTo60HzScreen);
}


//KitaoǉBeLXgbZ[Wݒ
void
SCREEN_SetMessageText(
	char*	pText)
{
	DDSCREEN_SetMessageText(pText);
}


/*-----------------------------------------------------------------------------
	[Deinit]
		XN[̏IsȂ܂B
-----------------------------------------------------------------------------*/
void
SCREEN_Deinit()
{
	DDSCREEN_Deinit();

	_Width = 0;
	_Height = 0;
	_BitsPerPixel = 0;
	_Flags = 0;
}

